package com.sheep.gamegroup.presenter;

import com.alibaba.fastjson.JSONObject;
import com.sheep.gamegroup.model.api.ApiService;
import com.sheep.gamegroup.model.entity.BaseMessage;
import com.sheep.gamegroup.model.util.SheepSubscriber;
import com.sheep.jiuyan.samllsheep.SheepApp;

import javax.inject.Inject;

import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;

/**
 * Created by ljy on 2018/3/18.
 */

public class BindOrChangeWeixinPresenter implements BindOrChangeWeixinContract.Presenter {

    private BindOrChangeWeixinContract.View view;
    private ApiService apiService;

    @Inject
    public BindOrChangeWeixinPresenter(BindOrChangeWeixinContract.View view, ApiService apiService) {
        this.view = view;
        this.apiService = apiService;
    }

    @Override
    public void bindWeixin(Object o) {
        apiService.bindWeixin(((JSONObject) o).getString("code"))
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new SheepSubscriber<BaseMessage>(SheepApp.getInstance()){

                    @Override
                    public void onNext(BaseMessage o) {

                        view.updateView(o);
                    }

                    @Override
                    public void onError(BaseMessage baseMessage) {


                        view.failData(baseMessage);
                    }
                });

    }
}
